package com.zksy.web.controller.basicData;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmEnterpriseTaxClassificationInfo;
import com.zksy.system.basicData.service.CrmEnterpriseTaxClassificationInfoService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.MergeReadsExcelUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * 纳税信用等级信息Controller
 *
 * @author sy
 * @date 2024-05-08
 */
@RestController
@RequestMapping("/crmEnterpriseTaxClassificationInfo")
@Api(tags = "纳税信用等级信息", description = "纳税信用等级信息desc")
public class CrmEnterpriseTaxClassificationInfoController extends BaseController {

    @Autowired
    private CrmEnterpriseTaxClassificationInfoService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "纳税信用等级信息搜索getById")
    public AjaxResult getById(@PathVariable String borrowId) {
        return AjaxResult.success(service.getById(borrowId));
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "纳税信用等级信息分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "纳税信用等级信息查询所有")
    public AjaxResult getList(String conditionJson) throws Exception {
        return AjaxResult.success(service.list(SearchUtil.parseWhereSql(conditionJson)));
    }

    /**
     * 新增纳税信用等级信息
     */
    @PostMapping("/save")
    @ApiOperation(value = "纳税信用等级信息新增")
    @Log(title = "新增纳税信用等级信息", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmEnterpriseTaxClassificationInfo crmEnterpriseTaxClassificationInfo) {
        return service.save(crmEnterpriseTaxClassificationInfo);
    }

    /**
     * 修改纳税信用等级信息
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "纳税信用等级信息修改")
    @Log(title = "修改纳税信用等级信息", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmEnterpriseTaxClassificationInfo crmEnterpriseTaxClassificationInfo) {
        return service.updateById(crmEnterpriseTaxClassificationInfo);
    }

    /**
     * 导入纳税信用等级信息
     */
    @ApiOperation("纳税信用等级信息导入")
    @Log(title = "纳税信用等级信息", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmEnterpriseTaxClassificationInfo> crmEnterpriseTaxClassificationInfoAll = service.list();
            //List<CrmEnterpriseTaxClassificationInfo> list = ExcelUtils.readMultipartFile(file, CrmEnterpriseTaxClassificationInfo.class,CrmEnterpriseTaxClassificationInfo.class.getDeclaredFields().length - 2);
            if(crmEnterpriseTaxClassificationInfoAll != null && crmEnterpriseTaxClassificationInfoAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            //excel单元格合并导入
            //参数：文件， 表头列数， 是否读取序号0-读取、1-不读取， 表头占的行数下标从0开始的
            List<Map<String,String>> list = MergeReadsExcelUtil.readExcelToObj(file, CrmEnterpriseTaxClassificationInfo.class.getDeclaredFields().length - 2,1,2,CrmEnterpriseTaxClassificationInfo.class);
            List<CrmEnterpriseTaxClassificationInfo> crmEnterpriseTaxClassificationInfo= JSON.parseObject(JSON.toJSONString(list), new TypeReference<List<CrmEnterpriseTaxClassificationInfo>>() {});
            if(list.size() > 0){
                service.saveBatch(crmEnterpriseTaxClassificationInfo);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("纳税信用等级信息导出")
    @Log(title = "纳税信用等级信息", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmEnterpriseTaxClassificationInfo> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"纳税信用等级信息",wrapperList,CrmEnterpriseTaxClassificationInfo.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "纳税信用等级信息", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除纳税信用等级信息", notes = "删除纳税信用等级信息")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }
    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"纳税信用等级信息模板");
    }
}

